// GraphicsView.cpp : implementation of the CGraphicsView class
//

#include "stdafx.h"
#include "Graphics.h"

#include "GraphicsDoc.h"
#include "GraphicsView.h"
#include "GetLineParameters.h"
#include "ScaleTransInfo.h"
#include "GetCircleParameters.h"
#include "PolygonDefinition.h"
#include "FloodFillSeed.h"

#include "Math.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SETPIXEL(x,y,z) pDC->SetPixel(x,y,z);m_MemDC.SetPixel(x,y,z)
#define MOVETO(x,y) pDC->MoveTo(x,y);m_MemDC.MoveTo(x,y);
#define LINETO(x,y) CPen *pPen,*pOldPen;pPen=new CPen(PS_SOLID,1,m_Color);pOldPen=pDC->SelectObject(pPen);pDC->LineTo(x,y);m_MemDC.LineTo(x,y);pPen=pDC->SelectObject(pOldPen);delete pPen;


#define TOP		1
#define BOTTOM	2
#define LEFT	4
#define	RIGHT	8

#define YMAX 480
#define XMAX 640

#define Clip_Left(x,y) y=m*(leftwindow-x1)+y1;x=leftwindow
#define Clip_Right(x,y) y=m*(rightwindow-x1)+y1;x=rightwindow
#define Clip_Bottom(x,y) x=minverse*(bottomwindow-y1)+x1;y=bottomwindow
#define Clip_Top(x,y) x=minverse*(topwindow-y1)+x1;y=topwindow

/////////////////////////////////////////////////////////////////////////////
// CGraphicsView

IMPLEMENT_DYNCREATE(CGraphicsView, CView)

BEGIN_MESSAGE_MAP(CGraphicsView, CView)
	//{{AFX_MSG_MAP(CGraphicsView)
	ON_COMMAND(ID_CHAPTER2_SIMPLEDDA, OnChapter2Simpledda)
	ON_COMMAND(ID_CHAPTER2_INTEGERDDA, OnChapter2Integerdda)
	ON_COMMAND(ID_CHAPTER2_CIRCLEINCREMENTALDRAWING, OnChapter2Circleincrementaldrawing)
	ON_COMMAND(ID_CHAPTER2_CIRCLELINESEGMENTSMETHOD, OnChapter2Circlelinesegmentsmethod)
	ON_COMMAND(ID_CHAPTER2_CIRCLEBRESENHAMSALGORITHM, OnChapter2Circlebresenhamsalgorithm)
	ON_COMMAND(ID_CHAPTER3_LINECLIPPING, OnChapter3Lineclipping)
	ON_COMMAND(ID_CHAPTER10_SCANLINEFILLING, OnChapter10Scanlinefilling)
	ON_COMMAND(ID_CHAPTER10_FLOODFILLING, OnChapter10Floodfilling)
	ON_COMMAND(ID_GENERAL_DEFINEPOLYGON, OnGeneralDefinepolygon)
	ON_COMMAND(ID_CHAPTER10_CONVEXFILLING, OnChapter10Convexfilling)
	ON_COMMAND(ID_CHAPTER10_GENERALPOLYGONFILLING, OnChapter10Generalpolygonfilling)
	ON_COMMAND(ID_CHAPTER3_POLYGONCLIPPINGSUTHERLANDHODGMAN, OnChapter3Polygonclippingsutherlandhodgman)
	ON_COMMAND(ID_GENERAL_SETDRAWINGCOLOR, OnGeneralSetdrawingcolor)
	ON_COMMAND(ID_GENERAL_DRAWPOLYGON, OnGeneralDrawpolygon)
	ON_COMMAND(ID_GENERAL_CLEARWINDOW, OnGeneralClearwindow)
	ON_COMMAND(ID_CHAPTER11_PRESPECTIVEPROJECTION, OnChapter11Prespectiveprojection)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphicsView construction/destruction

CGraphicsView::CGraphicsView()
{
	// TODO: add construction code here
	m_BitmapInitialized=FALSE;
	m_Color=RGB(0,0,0);

}

CGraphicsView::~CGraphicsView()
{
}

BOOL CGraphicsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGraphicsView drawing

void CGraphicsView::OnDraw(CDC* pDC)
{
	CGraphicsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	if(m_BitmapInitialized!=TRUE)
	{
		m_Bitmap.CreateCompatibleBitmap(pDC,XMAX,YMAX);
		m_MemDC.CreateCompatibleDC(pDC);
		m_MemDC.SelectObject(&m_Bitmap);
		m_MemDC.PatBlt(0,0,XMAX,YMAX,WHITENESS);
		for(int y=0;y<YMAX;y++)
			for(int x=0;x<XMAX;x++)
			{
				m_MemDC.SetPixel(x,y,RGB(255,255,255));
			}
		m_BitmapInitialized=TRUE;
	}
	pDC->BitBlt(0,0,XMAX,YMAX,&m_MemDC,0,0,SRCCOPY);
}

/////////////////////////////////////////////////////////////////////////////
// CGraphicsView printing

BOOL CGraphicsView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CGraphicsView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CGraphicsView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CGraphicsView diagnostics

#ifdef _DEBUG
void CGraphicsView::AssertValid() const
{
	CView::AssertValid();
}

void CGraphicsView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGraphicsDoc* CGraphicsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGraphicsDoc)));
	return (CGraphicsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGraphicsView message handlers
void CGraphicsView::HorizontalLine(int x1,int y,int x2)
{
	CClientDC *pDC;
	pDC=new CClientDC(this);
	for(int i=x1;i<x2;i++)
	{
		SETPIXEL(i,y,m_Color);
	}
}

void CGraphicsView::OnChapter2Simpledda() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	CGetLineParameters dlg;
	if(dlg.DoModal()!=IDOK) 
		return;
	int XStart,YStart,XEnd,YEnd;
	float absm;
	XStart=dlg.m_XStart;
	YStart=dlg.m_YStart;
	XEnd=dlg.m_XEnd;
	YEnd=dlg.m_YEnd;
	float xi,yi,xr,yr,m,minverse;
	m=(float)(YEnd-YStart)/(XEnd-XStart);
	if(m<0) 
		absm=m*(-1);
	else
		absm=m;
	if( (absm<1 && (XStart>XEnd)) || (absm>1 && (YStart>YEnd)) )
		Swap(XStart,YStart,XEnd,YEnd);		// Swap end points
	SETPIXEL(XStart,YStart,m_Color);
	if(abs(m)<1) 
	{
		yr=YStart;
		for(xi=XStart+1;xi<=XEnd-1;xi++)
		{
			yr=yr+m;
			SETPIXEL(xi,(int)yr,m_Color);
		}
	}
	else
	{
		minverse=1/m;
		xr=XStart;
		for(yi=YStart+1;yi<=YEnd-1;yi++)
		{
			xr=xr+minverse;
			SETPIXEL((int)xr,yi,m_Color);
		}
	}
	SETPIXEL(XEnd,YEnd,m_Color);
}

void CGraphicsView::Swap(int &x1,int &y1,int &x2,int &y2)
{
	int temp;
	temp=x2;
	x2=x1;
	x1=temp;
	temp=y2;
	y2=y1;
	y1=temp;
}

void CGraphicsView::OnChapter2Integerdda() 
{
	CClientDC *pDC;
	pDC=new CClientDC(this);
	CGetLineParameters dlg;
	if(dlg.DoModal()!=IDOK) 
		return;
	int XStart,YStart,XEnd,YEnd;
	float absm;
	XStart=dlg.m_XStart;
	YStart=dlg.m_YStart;
	XEnd=dlg.m_XEnd;
	YEnd=dlg.m_YEnd;
	int delta_x,delta_y,count,error,x,y;
	error=0;
	delta_x=XEnd-XStart;
	delta_y=YEnd-YStart;
	if(delta_y<0)
	{
		Swap(XStart,YStart,XEnd,YEnd);
		delta_y=-delta_y;
		delta_x=-delta_x;
	}
	SETPIXEL(XStart,YStart,m_Color);
	x=XStart;
	y=YStart;
	if(delta_x>=0
		)
		if(delta_x>=delta_y)
			for(count=1;count<=delta_x-1;count++)
				if(error<0)
				{
					x++;
					SETPIXEL(x,y,m_Color);
					error+=delta_y;
				}
				else
				{
					x++;
					y++;
					SETPIXEL(x,y,m_Color);
					error+=delta_y-delta_x;
				}
		else
			for(count=1;count<=delta_y-1;count++)
				if(error<0)
				{
					x++;
					y++;
					SETPIXEL(x,y,m_Color);
					error+=delta_y-delta_x;
				}
				else
				{
					y++;
					SETPIXEL(x,y,m_Color);
					error-=delta_x;
				}
	else
		if(abs(delta_x)>=delta_y)
			for(count=1;count<=abs(delta_x)-1;count++)
				if(error<0)
				{
					x--;
					SETPIXEL(x,y,m_Color);
					error+=delta_y;
				}
				else
				{
					x--;
					y++;
					SETPIXEL(x,y,m_Color);
					error+=delta_x+delta_y;
				}
		else
			for(count=1;count<=delta_y-1;count++)
				if(error<0)
				{
					x--;
					y++;
					SETPIXEL(x,y,m_Color);
					error+=delta_y+delta_y;
				}
				else
				{
					y++;
					SETPIXEL(x,y,m_Color);
					error+=delta_x;
				}
	SETPIXEL(XEnd,YEnd,m_Color);
}

void CGraphicsView::OnChapter2Circleincrementaldrawing() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	CGetCircleParameters dlg;
	if(dlg.DoModal()!=IDOK) 
		return;
	int xc,yc,Radius;
	xc=dlg.m_XC;
	yc=dlg.m_YC;
	Radius=dlg.m_Radius;
	float ar=1;
	float dtheta,ct,st,x,y,xtemp;
	dtheta=(float)1/Radius;
	ct=cos(dtheta);
	st=sin(dtheta);
	x=0;
	y=Radius;
	while(y>=x)
	{
		SETPIXEL(xc+x,yc+y*ar,m_Color);
		SETPIXEL(xc-x,yc+y*ar,m_Color);
		SETPIXEL(xc+x,yc-y*ar,m_Color);
		SETPIXEL(xc-x,yc-y*ar,m_Color);
		SETPIXEL(xc+y,yc+x*ar,m_Color);
		SETPIXEL(xc-y,yc+x*ar,m_Color);
		SETPIXEL(xc+y,yc-x*ar,m_Color);
		SETPIXEL(xc-y,yc-x*ar,m_Color);
		xtemp=x;
		x=x*ct-y*st;
		y=y*ct+xtemp*st;
	}
}

void CGraphicsView::OnChapter2Circlelinesegmentsmethod() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	CGetCircleParameters dlg;
	if(dlg.DoModal()!=IDOK) 
		return;
	int xc,yc,Radius;
	xc=dlg.m_XC;
	yc=dlg.m_YC;
	Radius=dlg.m_Radius;
	float two_Pi=6.28318,ar=1;
	float dtheta,ct,st;
	int count,xtemp;
	float x,y;
	dtheta=(float)two_Pi/(16*Radius);
	ct=cos(dtheta);
	st=sin(dtheta);
	x=0;
	y=Radius;
	MOVETO(xc+x,round(yc+y*ar));
	for(count=1;count<=16*Radius;count++)
	{
		xtemp=x;
		x=(float)(x*ct-y*st);
		y=(float)(y*ct+xtemp*st);
		LINETO(round((float)xc+x),round((float)yc+y*ar));
	}
}




void CGraphicsView::OnChapter2Circlebresenhamsalgorithm() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	CGetCircleParameters dlg;
	if(dlg.DoModal()!=IDOK) 
		return;
	int xc,yc,Radius;
	xc=dlg.m_XC;
	yc=dlg.m_YC;
	Radius=dlg.m_Radius;
	float ar=1;
	int x,y;
	y=Radius;
	for (x=0;x<=Radius/1.4142135623731;x++)
	{
		int dA,dB;
		int absdA,absdB;
		dA=(x+1)*(x+1)+y*y-Radius*Radius;
		dB=(x+1)*(x+1)+(y-1)*(y-1)-Radius*Radius;
		
		if(dA<0) 
			absdA=-dA;
		else
			absdA=dA;
		if(dB<0) 
			absdB=-dB;
		else
			absdB=dB;
		if(dA>0 && dB<0) // Circle passes between A&B
			if(absdA>absdB)
				y--;
		if(dA>0 && dB>=0)	// Circle passes through or below B
				y--;
		SETPIXEL(xc+x,yc+y*ar,m_Color);
		SETPIXEL(xc-x,yc+y*ar,m_Color);
		SETPIXEL(xc+x,yc-y*ar,m_Color);
		SETPIXEL(xc-x,yc-y*ar,m_Color);
		SETPIXEL(xc+y,yc+x*ar,m_Color);
		SETPIXEL(xc-y,yc+x*ar,m_Color);
		SETPIXEL(xc+y,yc-x*ar,m_Color);
		SETPIXEL(xc-y,yc-x*ar,m_Color);
	}
}

/* -------------------------------------------------------------------------------*/
/* The Next Section contains the procedures for/needed by the clipping algorithms */
/* -------------------------------------------------------------------------------*/

BYTE CGraphicsView::Region(int xend,int yend,int leftwindow,int rightwindow,int topwindow,int bottomwindow)
{
	BYTE endpoint=0;
	if(xend<leftwindow) 
		endpoint=endpoint|LEFT;
	else // else can be removed but this will degrade the performance!!!
		if(xend>rightwindow) 
			endpoint=endpoint|RIGHT;
	if(yend<bottomwindow) 
		endpoint=endpoint|BOTTOM;
	else
		if(yend>topwindow)
			endpoint=endpoint|TOP;		
	return endpoint;
}


void CGraphicsView::OnChapter3Lineclipping() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	CGetLineParameters dlg;
	if(dlg.DoModal()!=IDOK) 
		return;
	int x1,y1,x2,y2;
	x1=dlg.m_XStart;
	y1=dlg.m_YStart;
	x2=dlg.m_XEnd;
	y2=dlg.m_YEnd;
	if(dlg.DoModal()!=IDOK) 
		return;
	int leftwindow,rightwindow,topwindow,bottomwindow;
	leftwindow=dlg.m_XStart;
	bottomwindow=dlg.m_YStart;
	rightwindow=dlg.m_XEnd;
	topwindow=dlg.m_YEnd;
	
	BYTE dir1,dir2,dir;
	int x,y;
	float m,minverse;

	dir1=Region(x1,y1,leftwindow,rightwindow,topwindow,bottomwindow);
	dir2=Region(x2,y2,leftwindow,rightwindow,topwindow,bottomwindow);

	if(x1!=x2)
		m=(float)(y2-y1)/(x2-x1);
	if(y1!=y2)
		minverse=(float)(x2-x1)/(y2-y1);
	while(dir1!=0 || dir2!=0)
	{
		if((dir1 & dir2)!=0)
			return;
		if(dir1==0)
		{
			dir=dir2;
			x=x2;
			y=y2;
		}
		else
		{
			dir=dir1;
			x=x1;
			y=y1;
		}
		if(dir & LEFT)
		{
			Clip_Left(x,y);
		}
		else
			if(dir & RIGHT)
			{
				Clip_Right(x,y);
			}
		if(dir & BOTTOM)
		{
			Clip_Bottom(x,y);
		}
		else
			if(dir & TOP)
			{
				Clip_Top(x,y);
			}
		if(dir==dir1)
		{
			x1=x;
			y1=y;
			dir1=Region(x1,y1,leftwindow,rightwindow,topwindow,bottomwindow);
		}
		else
		{
			x2=x;
			y2=y;
			dir2=Region(x2,y2,leftwindow,rightwindow,topwindow,bottomwindow);
		}
	}
		MOVETO(x1,y1+1);
		LINETO(x2,y2+1);
}

void CGraphicsView::OnChapter10Scanlinefilling() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	int x,y,xstart;
	for(y=1;y<YMAX;y++)
	{
		x=1;
		do
		{
			while(pDC->GetPixel(x,y)==RGB(255,255,255) && x<XMAX)
				x++;
			if(x<XMAX)
			{
				x++;
				xstart=x;
				while(pDC->GetPixel(x,y)==RGB(255,255,255) && x<XMAX)
					x++;
				HorizontalLine(xstart,y,x);
				x++;
			}
		}
		while (x<XMAX);
	}
}

void CGraphicsView::OnChapter10Floodfilling() 
{
	// TODO: Add your command handler code here
		// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	CFloodFillSeed dlg;
	if(dlg.DoModal()!=IDOK) 
		return;
	int x,y;
	x=dlg.m_XC;
	y=dlg.m_YC;
	
	FloodFill(x,y);
}

void CGraphicsView::FloodFill(int x,int y)
{
	CClientDC *pDC;
	pDC=new CClientDC(this);
	static int depth=0;
	if(pDC->GetPixel(x,y)==RGB(255,255,255) && depth<3500)
	{
		depth++;
		SETPIXEL(x,y,m_Color);
		FloodFill(x+1,y);
		FloodFill(x-1,y);
		FloodFill(x,y+1);
		FloodFill(x,y-1);
		depth--;
	}
}


void CGraphicsView::OnGeneralDefinepolygon() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	CPolygonDefinition dlg;
	int index=0;
	while(dlg.DoModal()==IDOK)
	{
		m_PolygonX[index]=dlg.m_X;
		m_PolygonY[index]=dlg.m_Y;
		index++;
	}
m_PointsInPolygon=index;
}

void CGraphicsView::Calculate_x(int x1,int y1,int x2,int y2,int xval[])
{
	// used by convex filling
	float xreal,minverse;
	int temp,y;
	minverse=(float)(x2-x1)/(y2-y1);
	if(y1>y2)
	{
		temp=y1;
		y1=y2;
		y2=temp;
		temp=x1;
		x1=x2;
		x2=temp;
	}
	xval[y1]=x1;
	xval[y2]=x2;
	xreal=x1;
	y=y1+1;
	while(y<y2)
	{
		xreal=xreal+minverse;
		
		//xval[y]=round(xreal);
		int xint;
		xint=xreal;
		if(xreal-xint>=0.5)
			xval[y]=xint+1;
		else
			xval[y]=xint;
		
		y++;
	}
}

void CGraphicsView::OnChapter10Convexfilling() 
{
	// TODO: Add your command handler code here
	int xval[YMAX];
	struct table
	{
		int xmin,xmax;
	} scan_table[YMAX];
	for(int i=0;i<YMAX;i++)		// initialize all table
	{
		xval[i]=-1;
		scan_table[i].xmin=XMAX;
		scan_table[i].xmax=0;
	}

	for(i=0;i<m_PointsInPolygon;i++)
	{
		if(i!=m_PointsInPolygon-1)
			Calculate_x(m_PolygonX[i],m_PolygonY[i],m_PolygonX[i+1],m_PolygonY[i+1],xval);
		else
			Calculate_x(m_PolygonX[i],m_PolygonY[i],m_PolygonX[0],m_PolygonY[0],xval);
		for(int j=0;j<YMAX;j++)
		{
			if(xval[j]<scan_table[j].xmin && xval[j]>=0)
				scan_table[j].xmin=xval[j];
			if(xval[j]>scan_table[j].xmax && xval[j]>=0)
				scan_table[j].xmax=xval[j];
		}
	}
	for(i=0;i<YMAX;i++)
		if(scan_table[i].xmin<scan_table[i].xmax)
			HorizontalLine(scan_table[i].xmin,i,scan_table[i].xmax);
}

void CGraphicsView::OnChapter10Generalpolygonfilling() 
{
	// TODO: Add your command handler code here
/*
	m_PolygonX[0]=100;
	m_PolygonX[1]=200;
	m_PolygonX[2]=300;
	m_PolygonX[3]=180;
	m_PolygonY[0]=100;
	m_PolygonY[1]=50;
	m_PolygonY[2]=120;
	m_PolygonY[3]=200;
	m_PointsInPolygon=4;
	
	m_PolygonX[0]=90;
	m_PolygonX[1]=20;
	m_PolygonX[2]=30;
	m_PolygonX[3]=40;
	m_PolygonX[4]=60;
	m_PolygonX[5]=80;
	m_PolygonX[6]=110;

	m_PolygonY[0]=10;
	m_PolygonY[1]=10;
	m_PolygonY[2]=30;
	m_PolygonY[3]=70;
	m_PolygonY[4]=50;
	m_PolygonY[5]=80;
	m_PolygonY[6]=40;
	
	m_PointsInPolygon=7;*/

	CreateTable();		// pre -algorithm!
	for(int i=0;i<YMAX;i++)
	{
		if(edge_table[i]!=NULL)
		{
			yval=i;
			i=YMAX+1;
		}
	}

	scan_line=0;
	int TopMostScanLineInPolygon=0;
	for(i=0;i<m_PointsInPolygon;i++)
		if(m_PolygonY[i]>TopMostScanLineInPolygon)
			TopMostScanLineInPolygon=m_PolygonY[i];
	
	while(yval<TopMostScanLineInPolygon)
	{
		Merge(edge_table[yval],scan_line);
		Fill_Scan(yval);
		Remove();
				
		// Increment the xmin value by m_inverse for those remaining edges
		// in the scan_line list:
		struct edge_info *ptr;
		ptr=scan_line;
	/*	if(ptr!=NULL)
			while(ptr->next!=NULL)
			{
				ptr->xmin+=ptr->m_inverse;
				ptr=ptr->next;
			}*/

		// Resort the scan_line list on increasing xmin value
		Resort();

		// Increment the current scan line y value by 1 to give the next scan line
		yval++;
	}
	
}

void CGraphicsView::Insert(struct edge_info *node,struct edge_info *&list)
{
	struct edge_info *trav,*trl;
	if(list==NULL)
		list=node;
	else
		if(node->xmin<=list->xmin)
		{
			// insert @ front of list
			node->next=list;
			list=node;
		}
		else
		{
			trav=list;
			while(trav->next!=NULL && trav->xmin<node->xmin)
			{
				trl=trav;
				trav=trav->next;
			}
			if(trav->next==NULL && trav->xmin<node->xmin)
				trav->next=node;
			else
			{
				node->next=trav;
				trl->next=node;
			}
		}
}

float CGraphicsView::Inverse(int i)
{
	float inv;
	if(m_PolygonY[i]==m_PolygonY[(i+1)%m_PointsInPolygon])
		inv=0;
	else 
		inv=(float)(m_PolygonX[i]-m_PolygonX[(i+1)%m_PointsInPolygon])/(m_PolygonY[i]-m_PolygonY[(i+1)%m_PointsInPolygon]);
	if((i+1)!=(i+1)%m_PointsInPolygon)
		i=i;
	return inv;
}

void CGraphicsView::CreateTable(void)
{
	int yval,k;
	struct edge_info *node;
	
	for(yval=0;yval<YMAX;yval++)
		edge_table[yval]=NULL;

	for(k=0;k<=m_PointsInPolygon-1;k++)
	{
		node=new struct edge_info;
		node->m_inverse=Inverse(k);
		node->next=NULL;
	if(m_PolygonY[k]>m_PolygonY[(k+1) % m_PointsInPolygon])
	{
		node->ytop=m_PolygonY[k];
		if(m_PolygonY[(k+1)%m_PointsInPolygon] < m_PolygonY[(k+2) % m_PointsInPolygon])
		{
			node->xmin=m_PolygonX[(k+1)%m_PointsInPolygon];
			Insert(node,edge_table[m_PolygonY[(k+1)%m_PointsInPolygon]]);
		}
		else
		{
			node->xmin=m_PolygonX[(k+1)%m_PointsInPolygon]+node->m_inverse;
			Insert(node,edge_table[m_PolygonY[(k+1)%m_PointsInPolygon]+1]);
		}
	}
	else
		if(m_PolygonY[k]<m_PolygonY[(k+1)%m_PointsInPolygon])
		{
			node->ytop=m_PolygonY[(k+1)%m_PointsInPolygon];
			if(m_PolygonY[k]<m_PolygonY[(k-1) % m_PointsInPolygon])
			{
				node->xmin=m_PolygonX[k];
				Insert(node,edge_table[m_PolygonY[k]]);
			}
			else
			{
				node->xmin=m_PolygonX[k]+node->m_inverse;
				Insert(node,edge_table[m_PolygonY[k]+1]);
			}
		}
	}
}

void CGraphicsView::Merge(struct edge_info *&newlist,struct edge_info *&oldlist)
{
	struct edge_info *temp,*newptr,*ptr;
	if(oldlist==NULL)
		oldlist=newlist;
	else
	{
		newptr=newlist;
		while(newptr!=NULL)
		{
			temp=newptr->next;
			Insert(newptr,oldlist);
			newptr=temp;
		}
	}
}

void CGraphicsView::Remove(void)
{
	struct edge_info *trav,*trl;
	trav=scan_line;
	while(trav!=NULL)
	{
		if(trav==scan_line)
			if(trav->ytop==yval)
			{
				scan_line=scan_line->next;
				trav=scan_line;
				trl=NULL;
			}
			else
			{
				trl=trav;
				trav=trav->next;
			}
		else
		{
			if(trav->ytop==yval)
				trl->next=trav->next;
			else
				trl=trav;
			trav=trav->next;
		}
	}
}



void CGraphicsView::Resort(void)
{
	struct edge_info *sortptr,*sortnext;
	scan_line->xmin=scan_line->xmin+scan_line->m_inverse;
	sortptr=scan_line->next;
	scan_line->next=NULL;
	while(sortptr!=NULL)
	{
		sortptr->xmin=sortptr->xmin+sortptr->m_inverse;
		sortnext=sortptr->next;
		sortptr->next=NULL;
		Insert(sortptr,scan_line);
		sortptr=sortnext;
	}
}

int CGraphicsView::round(float n)
{
	int a,b;
	a=n;

	if((float)(n-a)>0.5)
		b=a+1;
	else b=a;
	return b;
}

void CGraphicsView::Fill_Scan(int yval)
{
	CClientDC *pDC;
	pDC=new CClientDC(this);

	int k;
	struct edge_info *trav;

	k=0;
	if(scan_line!=NULL)
	{
		trav=scan_line;
		while(trav!=NULL)
		{
			k++;
			if(k%2==1)
			{
			MOVETO(round(trav->xmin),yval);
			}
			else
			{
				LINETO(round(trav->xmin),yval);
			}
			trav=trav->next;
		}
	}
}


					

BOOL CGraphicsView::Inside(int x,int y,float limit,int side)
{
	BOOL returnvalue;
	switch(side)
	{
	case TOP: 
				returnvalue=(y>=limit);
				break;
	case BOTTOM:
				returnvalue=(y<=limit);
				break;
	case LEFT:
				returnvalue=(x>=limit);
				break;
	case RIGHT:
				returnvalue=(x<=limit);
				break;
	}
return returnvalue;
}

void CGraphicsView::Out(int x,int y)
{
	outlen++;
	PolyoutX[outlen]=x;
	PolyoutY[outlen]=y;
}


void CGraphicsView::Intersect(float x1,float y1,float x2,float y2,int limit,int Edge,float* Tempx,float* Tempy)
{
	if(Edge==LEFT)
	{
		if(x1==x2)
			return;     //The line is vertical
		float Slope = (y2 - y1)/(x2- x1);
		*Tempx = limit;
		*Tempy = y2 + ( Slope*(*Tempx-x2) );
		*Tempy=y1+(Slope*(*Tempx-x1));
		//i.y=m*limit-v1.x+v1.y
	}
	if(Edge==RIGHT)
	{
		if(x1==x2)
			return;    //The line is vertical

		float Slope = (y2 - y1)/(x2- x1);
		*Tempx = limit;
		*Tempy = y2 + ( Slope*(*Tempx-x2) );
		*Tempy=y1+(Slope*(*Tempx-x1));		
	}
	if(Edge==TOP)
	{
		if(y1==y2)
			return;    //The line is horizontal

		float SlopeInv = (x2 - x1)/(y2- y1);
		*Tempy = limit;
		*Tempx = x2 + ( SlopeInv*(*Tempy-y2) );
		*Tempx=x1+(SlopeInv*(*Tempy-y1));
	}
	if(Edge==BOTTOM)
	{
		if(y1==y2)
			return;    //The line is horizontal
	
		float SlopeInv = (x2 - x1)/(y2- y1);
		*Tempy = limit;
		*Tempx = x2 + ( SlopeInv*(*Tempy-y2) );
		*Tempx=x1+(SlopeInv*(*Tempy-y1));
	}

}




void CGraphicsView::Suth_Hodg(float edgelimit,int edgeside)
{
	int j;
	int v1x,v1y,v2x,v2y,ix,iy;
	float a,b;
	
	outlen=0;
	v1x=m_PolygonX[m_PointsInPolygon];
	v1y=m_PolygonY[m_PointsInPolygon];
	for(j=1;j<=m_PointsInPolygon;j++)
	{
		v2x=m_PolygonX[j];
		v2y=m_PolygonY[j];
		if (Inside(v2x,v2y,edgelimit,edgeside))
			if(Inside(v1x,v1y,edgelimit,edgeside))
				Out(v2x,v2y);
			else
			{
				Intersect(v1x,v1y,v2x,v2y,edgelimit,edgeside,&a,&b);
				ix=a;iy=b;
				Out(ix,iy);
				Out(v2x,v2y);
			}
		else
			if(Inside(v1x,v1y,edgelimit,edgeside))
			{
				Intersect(v1x,v1y,v2x,v2y,edgelimit,edgeside,&a,&b);
				ix=a;iy=b;
				Out(ix,iy);
			}
			v1x=v2x;
			v1y=v2y;
	}
}





void CGraphicsView::OnChapter3Polygonclippingsutherlandhodgman() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	CGetLineParameters dlg;
	if(dlg.DoModal()!=IDOK) 
		return;
	int X1,Y1,X2,Y2;
	X1=dlg.m_XStart;
	Y1=dlg.m_YStart;
	X2=dlg.m_XEnd;
	Y2=dlg.m_YEnd;
	for(int i=m_PointsInPolygon;i>0;i--)
	{
		m_PolygonX[i]=m_PolygonX[i-1];
		m_PolygonY[i]=m_PolygonY[i-1];
	}


	Suth_Hodg(X1,LEFT);
	for(i=0;i<=100;i++)
	{
		m_PolygonX[i]=PolyoutX[i];
		m_PolygonY[i]=PolyoutY[i];
	}
	m_PointsInPolygon=outlen;
	Suth_Hodg(X2,RIGHT);
	for(i=0;i<=100;i++)
	{
		m_PolygonX[i]=PolyoutX[i];
		m_PolygonY[i]=PolyoutY[i];
	}
	m_PointsInPolygon=outlen;

	Suth_Hodg(Y1,TOP);
	for(i=0;i<=100;i++)
	{
		m_PolygonX[i]=PolyoutX[i];
		m_PolygonY[i]=PolyoutY[i];
	}
	m_PointsInPolygon=outlen;
	Suth_Hodg(Y2,BOTTOM);
	for(i=0;i<=100;i++)
	{
		m_PolygonX[i]=PolyoutX[i];
		m_PolygonY[i]=PolyoutY[i];
	}
	m_PointsInPolygon=outlen;

	for( i=0;i<m_PointsInPolygon;i++)
	{
		m_PolygonX[i]=m_PolygonX[i+1];
		m_PolygonY[i]=m_PolygonY[i+1];
	}
	

}


void CGraphicsView::OnGeneralSetdrawingcolor() 
{
	// TODO: Add your command handler code here
	CColorDialog dlg;
	if(dlg.DoModal()!=IDOK)
		return;
	m_Color=dlg.GetColor();	
	
	CClientDC *pDC;
	pDC=new CClientDC(this);
	CPen *pPen;
	pPen=new CPen(PS_SOLID,1,m_Color);
	pDC->SelectObject(pPen);
	pPen=new CPen(PS_SOLID,1,m_Color);
	m_MemDC.SelectObject(pPen);
}

void CGraphicsView::OnGeneralDrawpolygon() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	for(int i=0;i<m_PointsInPolygon;i++)
	{
		MOVETO(m_PolygonX[i],m_PolygonY[i]);
		LINETO(m_PolygonX[(i+1)%m_PointsInPolygon],m_PolygonY[(i+1)%m_PointsInPolygon]);
	}
	
	
}

void CGraphicsView::OnGeneralClearwindow() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	for(int y=0;y<YMAX;y++)
			for(int x=0;x<XMAX;x++)
			{
				SETPIXEL(x,y,RGB(255,255,255));
			}
}

float CGraphicsView::Dot_Prod(float v1[4],float v2[4])
{
	return v1[0]*v2[0]+v1[1]*v2[1]+v1[2]*v2[2];
}
void CGraphicsView::Cross_Prod(float v1[4],float v2[4],float result[4])
{
	result[0]=v1[1]*v2[2]-v1[2]*v2[1];
	result[1]=v1[2]*v2[0]-v1[0]*v2[2];
	result[2]=v1[0]*v2[1]-v1[1]*v2[0];
	result[3]=1;
}
void CGraphicsView::Normalize(float v1[4])
{
float length;
length=sqrt(Dot_Prod(v1,v1));
for (index=0;index<3;index++)
	v1[index]=v1[index]/length;
}

void CGraphicsView::Multiply_Mat(float A[4][4],float B[4][4],float C[4][4])
{
int i,j,k;
for(i=0;i<4;i++)
	for(j=0;j<4;j++)
	{
		C[i][j]=0;
		for(k=0;k<4;k++)
			C[i][j]+=A[i][k]*B[k][j];
	}
}
void CGraphicsView::Multiply_Vec(float A[4][4],float v1[4],float v2[4])
{
for(int i=0;i<4;i++)
	v2[i]=v1[0]*A[0][i]+v1[1]*A[1][i]+v1[2]*A[2][i]+v1[3]*A[3][i];
}
void CGraphicsView::Subtract_Vec(float v1[4],float v2[4],float result[4])
{
result[0]=v1[0]-v2[0];
result[1]=v1[1]-v2[1];
result[2]=v1[1]-v2[2];
result[3]=1;
}




void CGraphicsView::OnChapter11Prespectiveprojection() 
{
	// TODO: Add your command handler code here
	CClientDC *pDC;
	pDC=new CClientDC(this);
	float temp;

	char t[10];
	CFileDialog *fd;
	fd=new CFileDialog(TRUE,".dat",NULL,NULL,"Data Files (*.dat)|*.dat|All Files|*.*||",this);
	BOOL DialogResult;
	DialogResult=fd->DoModal();

	CString fn;
	LPTSTR filename;
	fn=fd->GetPathName();
	delete fd;
	if (DialogResult==IDCANCEL)
		return;
	filename=fn.GetBuffer(1);


	CScaleTransInfo dlg;
	if(dlg.DoModal()!=IDOK) 
		return;
	int dispx,dispy,scalx,scaly;
	dispx=dlg.m_XTrans;
	dispy=dlg.m_YTrans;
	scalx=dlg.m_XScale;
	scaly=dlg.m_YScale;


	FILE *fptr;
	fptr=fopen(filename,"r");
	fn.ReleaseBuffer();
	COP[3]=VRP[3]=VPN[3]=VUP[3]=1;								// the fourth component
	fscanf(fptr,"%s %f %f %f",t,&COP[0],&COP[1],&COP[2]);		// COP
	fscanf(fptr,"%s %f %f %f",t,&VRP[0],&VRP[1],&VRP[2]);		// VRP
	fscanf(fptr,"%s %f %f %f",t,&VPN[0],&VPN[1],&VPN[2]);		// VPN
	fscanf(fptr,"%s %f %f %f",t,&VUP[0],&VUP[1],&VUP[2]);		// VUP
	fscanf(fptr,"%s %f",t,&F);									// F
	fscanf(fptr,"%s %f",t,&B);			 						// B
	fscanf(fptr,"%s %f",t,&UMAX);								// UMAX
	fscanf(fptr,"%s %f",t,&UMIN);								// UMIN
	fscanf(fptr,"%s %f",t,&VMAX);								// VMAX
	fscanf(fptr,"%s %f",t,&VMIN);								// VMIN
	fscanf(fptr,"%s %i",t,&N);								// N=number of polygons

	float a[4][4],b[4][4];
	float c[4],d[4],e[4];
	c[0]=2;c[1]=3;c[2]=4;c[3]=1;
	e[0]=1;e[1]=2;e[2]=3;e[3]=1;
	a[0][0]=1;		a[0][1]=2;	a[0][2]=3;	a[0][3]=4;
	a[1][0]=5;		a[1][1]=6;	a[1][2]=7;	a[1][3]=8;
	a[2][0]=9;		a[2][1]=10;	a[2][2]=11;	a[2][3]=12;
	a[3][0]=13;		a[3][1]=14;	a[3][2]=15;	a[3][3]=16;

	Multiply_Mat(a,a,b);
	//Multiply_Vec(c,c,d);
	Cross_Prod(c,e,d);
	float s;
	s=Dot_Prod(c,e);



	for(int i=0;i<N;i++)
	{
	fscanf(fptr,"%s %i",t,&m_PolygonSizes[i]);				// number of points in polygon i
	for(int j=0;j<m_PolygonSizes[i];j++)
	{
		fscanf(fptr,"%f %f %f",&m_Polygons[i][j][0],&m_Polygons[i][j][1],&m_Polygons[i][j][2]);
		/*m_Polygons[i][j][0]*=50;
		m_Polygons[i][j][1]*=50;
		m_Polygons[i][j][2]*=50;*/
		m_Polygons[i][j][3]=1;
	}
	}
	fclose(fptr);


	Normalize(VPN);
	scalar=Dot_Prod(VPN,VUP);
	for(i=0;i<3;i++)
		tempvect[i]=scalar*VPN[i];
	tempvect[3]=1;
	Subtract_Vec(VUP,tempvect,v);
	Cross_Prod(VPN,v,u);
	Normalize(v);
	Normalize(u);

	T[0][0]=1;					T[0][1]=0;					T[0][2]=0;					T[0][3]=0;
	T[1][0]=0;					T[1][1]=1;					T[1][2]=0;					T[1][3]=0;
	T[2][0]=0;					T[2][1]=0;					T[2][2]=1;					T[2][3]=0;
	T[3][0]=-(VRP[0]+COP[0]);	T[3][1]=-(VRP[1]+COP[1]);	T[3][2]=-(VRP[2]+COP[2]);	T[3][3]=1;
	//Multiply_Vec(T,m_Polygons[0][1],m_Polygons[0][2]);
	
	R[0][0]=u[0];	R[0][1]=v[0];	R[0][2]=-VPN[0]; R[0][3]=0;
	R[1][0]=u[1];	R[1][1]=v[1];	R[1][2]=-VPN[1]; R[1][3]=0;
	R[2][0]=u[2];	R[2][1]=v[2];	R[2][2]=-VPN[2]; R[2][3]=0;
	R[3][0]=0;		R[3][1]=0;		R[3][2]=0;		 R[3][3]=1;


	Ch[0][0]=1;		Ch[0][1]=0;		Ch[0][2]=0;		Ch[0][3]=0;
	Ch[1][0]=0;		Ch[1][1]=1;		Ch[1][2]=0;		Ch[1][3]=0;
	Ch[2][0]=0;		Ch[2][1]=0;		Ch[2][2]=-1;	Ch[2][3]=0;
	Ch[3][0]=0;		Ch[3][1]=0;		Ch[3][2]=0;		Ch[3][3]=1;

	Multiply_Mat(R,Ch,Rot);
	Multiply_Mat(T,Rot,Viewmat);
	Multiply_Vec(Viewmat,VRP,VRPprime);

	CENT[0]=VRPprime[0]+0.5*(UMAX+UMIN);
	CENT[1]=VRPprime[1]+0.5*(VMAX+VMIN);
	CENT[2]=VRPprime[2];

	Sh[0][0]=1;						Sh[0][1]=0;						Sh[0][2]=0;		Sh[0][3]=0;
	Sh[1][0]=0;						Sh[1][1]=1;						Sh[1][2]=0;		Sh[1][3]=0;
	Sh[2][0]=-CENT[0]/CENT[2];		Sh[2][1]=-CENT[1]/CENT[2];		Sh[2][2]=1;		Sh[2][3]=0;
	Sh[3][0]=0;						Sh[3][1]=0;						Sh[3][2]=0;		Sh[3][3]=1;

	Multiply_Mat(Viewmat,Sh,TempTrans);		// get the combined transformation TxRotxSh

	float Sx,Sy,Sz;

	Sx=2*(VRPprime[2])/((UMAX-UMIN)*(VRPprime[2]+B));
	Sy=2*(VRPprime[2])/((VMAX-VMIN)*(VRPprime[2]+B));
	Sz=1/(VRPprime[2]+B);

	Sc[0][0]=Sx;					Sc[0][1]=0;						Sc[0][2]=0;		Sc[0][3]=0;
	Sc[1][0]=0;						Sc[1][1]=Sy;					Sc[1][2]=0;		Sc[1][3]=0;
	Sc[2][0]=0				;		Sc[2][1]=0;						Sc[2][2]=Sz;	Sc[2][3]=0;
	Sc[3][0]=0;						Sc[3][1]=0;						Sc[3][2]=0;		Sc[3][3]=1;	

	Multiply_Mat(TempTrans,Sc,Trans);
	
	float D;
	D=VRPprime[2]/(VRPprime[2]+B);

	for(i=0;i<N;i++)
	{
		float tempvect[4];
		Multiply_Vec(Trans,m_Polygons[i][0],tempvect);
		tempvect[0]*=D/tempvect[2];tempvect[1]*=D/tempvect[2];
		tempvect[0]*=scalx;tempvect[1]*=scaly;

		
		tempvect[0]+=dispx;tempvect[1]+=dispy;//tempvect[2]+=100;

		MOVETO(tempvect[0],tempvect[1]);
		for(int j=1;j<m_PolygonSizes[i];j++)
		{
			Multiply_Vec(Trans,m_Polygons[i][j],tempvect);
			
			tempvect[0]*=D/tempvect[2];tempvect[1]*=D/tempvect[2];
			tempvect[0]*=scalx;tempvect[1]*=scaly;
			tempvect[0]+=dispx;tempvect[1]+=dispy;//tempvect[2]+=100;
			LINETO(tempvect[0],tempvect[1]);
		}
		Multiply_Vec(Trans,m_Polygons[i][0],tempvect);
		
		tempvect[0]*=D/tempvect[2];tempvect[1]*=D/tempvect[2];
		tempvect[0]*=scalx;tempvect[1]*=scaly;
		tempvect[0]+=dispx;tempvect[1]+=dispy;//tempvect[2]+=100;

		LINETO(tempvect[0],tempvect[1]);
	}

}
