// GraphicsView.h : interface of the CGraphicsView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAPHICSVIEW_H__CD13F4D3_5EBE_11D2_993E_525400DAFA2D__INCLUDED_)
#define AFX_GRAPHICSVIEW_H__CD13F4D3_5EBE_11D2_993E_525400DAFA2D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define YMAX 480
#define XMAX 640

class CGraphicsView : public CView
{
protected: // create from serialization only
	CGraphicsView();
	DECLARE_DYNCREATE(CGraphicsView)

// Attributes
public:
	CGraphicsDoc* GetDocument();

private:
	void Swap(int &x1,int &y1,int &x2,int &y2);
	BYTE Region(int xend,int yend,int leftwindow,int rightwindow,int topwindow,int bottomwindow);
	void HorizontalLine(int x1,int y,int x2);
	void FloodFill(int x,int y);
	CBitmap m_Bitmap;
	BOOL m_BitmapInitialized;
	CDC m_MemDC;
	COLORREF m_Color;
	
	// The next section belongs to the convex polygon filling
	int m_PolygonX[100],m_PolygonY[100],m_PointsInPolygon;
	void Calculate_x(int x1,int y1,int x2,int y2,int xval[]);

	// The next section belongs to the polygon clipping
	int outlen;
	int PolyoutX[100],PolyoutY[100];
	void Suth_Hodg(float edgelimit,int edgeside);
	void Intersect(float x1,float y1,float x2,float y2,int limit,int Edge,float* Tempx,float* Tempy);	
	void Out(int x,int y);
	BOOL Inside(int x,int y,float limit,int side);
	
	// The next secton belongs to the general polygon filling
	struct edge_info
	{
		int ytop;
		float xmin,m_inverse;
		struct edge_info *next;
	};
	struct edge_info *edge_table[YMAX],*scan_line;
	int yval;
	void Insert(struct edge_info &node,struct edge_info *list);
	void Insert(struct edge_info *node,struct edge_info *&list);
	float Inverse(int i);
	void CreateTable(void);
	void Merge(struct edge_info *&newlist,struct edge_info *&oldlist);
	void Remove(void);
	void Resort(void);
	int round(float n);
	void Fill_Scan(int yval);

	// The next section belongs to the 3D part
	float VPN[4],VUP[4],COP[4],u[4],v[4],CENT[4],P[4],PPRIME[4],VRP[4],VRPprime[4],tempvect[4];
	float T[4][4],R[4][4],Ch[4][4],Rot[4][4],Sh[4][4],Sc[4][4],Viewmat[4][4],TempTrans[4][4],Trans[4][4];
	float F,B,UMIN,UMAX,VMIN,VMAX;
	int N;
	float scalar;
	int index;
	float Dot_Prod(float v1[4],float v2[4]);
	void Cross_Prod(float v1[4],float v2[4],float result[4]);
	void Normalize(float v1[4]);
	void Multiply_Mat(float A[4][4],float B[4][4],float c[4][4]);
	void Multiply_Vec(float A[4][4],float v1[4],float v2[4]);
	void Subtract_Vec(float v1[4],float v2[4],float result[4]);
	float m_Polygons[10][10][4];	// a max of 10 polygons, 10 points/polygon
	int m_PolygonSizes[10];

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGraphicsView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGraphicsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGraphicsView)
	afx_msg void OnChapter2Simpledda();
	afx_msg void OnChapter2Integerdda();
	afx_msg void OnChapter2Circleincrementaldrawing();
	afx_msg void OnChapter2Circlelinesegmentsmethod();
	afx_msg void OnChapter2Circlebresenhamsalgorithm();
	afx_msg void OnChapter3Lineclipping();
	afx_msg void OnChapter10Scanlinefilling();
	afx_msg void OnChapter10Floodfilling();
	afx_msg void OnGeneralDefinepolygon();
	afx_msg void OnChapter10Convexfilling();
	afx_msg void OnChapter10Generalpolygonfilling();
	afx_msg void OnChapter3Polygonclippingsutherlandhodgman();
	afx_msg void OnGeneralSetdrawingcolor();
	afx_msg void OnGeneralDrawpolygon();
	afx_msg void OnGeneralClearwindow();
	afx_msg void OnChapter11Prespectiveprojection();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GraphicsView.cpp
inline CGraphicsDoc* CGraphicsView::GetDocument()
   { return (CGraphicsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRAPHICSVIEW_H__CD13F4D3_5EBE_11D2_993E_525400DAFA2D__INCLUDED_)
